import getKiloName from './getLongKiloName'

it('should exist', () => {
  expect(getKiloName).toBeDefined()
})

it('should be a callable', () => {
  expect(typeof getKiloName).toBe('function')
})

it('should accept 1 argument', () => {
  expect(getKiloName).toHaveLength(1)
})

test.each`
  thousandPower | name
  ${0}          | ${''}
  ${1}          | ${'Tausend'}
  ${2}          | ${'Million'}
  ${3}          | ${'Milliard'}
  ${4}          | ${'Billion'}
  ${5}          | ${'Billiard'}
  ${6}          | ${'Trillion'}
  ${7}          | ${'Trilliard'}
  ${8}          | ${'Quadrillion'}
  ${9}          | ${'Quadrilliard'}
  ${10}         | ${'Quintillion'}
  ${11}         | ${'Quintilliard'}
  ${12}         | ${'Sextillion'}
  ${13}         | ${'Sextilliard'}
  ${14}         | ${'Septillion'}
  ${15}         | ${'Septilliard'}
  ${16}         | ${'Octillion'}
  ${17}         | ${'Octilliard'}
  ${18}         | ${'Nonillion'}
  ${19}         | ${'Nonilliard'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${20}         | ${'Decillion'}
  ${40}         | ${'Vigintillion'}
  ${60}         | ${'Trigintillion'}
  ${80}         | ${'Quadragintillion'}
  ${100}        | ${'Quinquagintillion'}
  ${120}        | ${'Sexagintillion'}
  ${140}        | ${'Septuagintillion'}
  ${160}        | ${'Octogintillion'}
  ${180}        | ${'Nonagintillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${200}        | ${'Centillion'}
  ${400}        | ${'Duocentillion'}
  ${600}        | ${'Trecentillion'}
  ${800}        | ${'Quadringentillion'}
  ${1000}       | ${'Quingentillion'}
  ${1200}       | ${'Sescentillion'}
  ${1400}       | ${'Septingentillion'}
  ${1600}       | ${'Octingentillion'}
  ${1800}       | ${'Nongentillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${2000}       | ${'Milliatillion'}
  ${4000}       | ${'Duomilliatillion'}
  ${6000}       | ${'Tremilliatillion'}
  ${8000}       | ${'Quattuormilliatillion'}
  ${10000}      | ${'Quinmilliatillion'}
  ${12000}      | ${'Sexmilliatillion'}
  ${14000}      | ${'Septenmilliatillion'}
  ${16000}      | ${'Octomilliatillion'}
  ${18000}      | ${'Novemmilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${20000}      | ${'Decmilliatillion'}
  ${40000}      | ${'Viginmilliatillion'}
  ${60000}      | ${'Triginmilliatillion'}
  ${80000}      | ${'Quadraginmilliatillion'}
  ${100000}     | ${'Quinquaginmilliatillion'}
  ${120000}     | ${'Sexaginmilliatillion'}
  ${140000}     | ${'Septuaginmilliatillion'}
  ${160000}     | ${'Octoginmilliatillion'}
  ${180000}     | ${'Nonaginmilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${200000}     | ${'Cenmilliatillion'}
  ${400000}     | ${'Duocenmilliatillion'}
  ${600000}     | ${'Trecenmilliatillion'}
  ${800000}     | ${'Quadringenmilliatillion'}
  ${1000000}    | ${'Quingenmilliatillion'}
  ${1200000}    | ${'Sescenmilliatillion'}
  ${1400000}    | ${'Septingenmilliatillion'}
  ${1600000}    | ${'Octingenmilliatillion'}
  ${1800000}    | ${'Nongenmilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})

test.each`
  thousandPower | name
  ${2000000}    | ${'Milliamilliatillion'}
  ${4000000}    | ${'Duomilliamilliatillion'}
  ${6000000}    | ${'Tremilliamilliatillion'}
  ${8000000}    | ${'Quattuormilliamilliatillion'}
  ${10000000}   | ${'Quinmilliamilliatillion'}
  ${12000000}   | ${'Sexmilliamilliatillion'}
  ${14000000}   | ${'Septenmilliamilliatillion'}
  ${16000000}   | ${'Octomilliamilliatillion'}
  ${18000000}   | ${'Novemmilliamilliatillion'}
`('should return "$name" for 1000^$thousandPower', ({ name, thousandPower, }) => {
  expect(getKiloName(thousandPower)).toBe(name)
})
